package com.mgyun.shua.engine;

import android.content.Context;

public class AmendBuilder extends ScriptBuilder{
	public static String convertToRootPath(String path){
		path = replaceStart(path, "/system", "SYSTEM:");
		path = replaceStart(path, "/data", "DATA:");
		path = replaceStart(path, "/cache", "CACHE:");
		path = replaceStart(path, "/sdcard", "SDCARD:");
		path = replaceStart(path, "/mnt/sdcard", "SDCARD:");
		path = replaceStart(path, "/sd-ext", "SDEXT:");
		path = replaceStart(path, "/datadata", "DATADATA:");
		return path;
	}
	

	@Override
	public void backup(String path){
		appendLine("backup_rom %s", path);
	}

	@Override
	public void format(String path) {
		appendLine("format %s", convertToRootPath(path));
	}

	@Override
	public void installZip(String path){
		appendLine("install_zip %s", convertToRootPath(path));
	}

	@Override
	public void print(String format, Object... args){
		appendLine(FlushUtils.getString(ShuaString.strUiPrint),
				String.format(format, args).replace("\"", "\\\""));
	}

	@Override
	public void restore(String path, boolean boot, boolean system,
			boolean data, boolean cache, boolean sdext){
		Object[] args = new Object[6];
		args[0] = path;
		if (boot)
			args[1] = "boot";
		else
			args[1] = "noboot";
		if (system)
			args[2] = "system";
		else
			args[2] = "nosystem";
		if (data)
			args[3] = "data";
		else
			args[3] = "nodata";
		if (cache)
			args[4] = "cache";
		else
			args[4] = "nocache";
		if (sdext)
			args[5] = "sd-ext";
		else
			args[5] = "nosd-ext";
		
		appendLine(FlushUtils.getString(ShuaString.strRestoreRom), args);
		//appendLine("restore_rom %s %s %s %s %s %s", args);
	}

	@Override
	public void runProgram(String program, String... args){
		String allArgs = "";
		for (int i=0; i<args.length; i++){
			allArgs += " " + args[i];
		}
		appendLine("run_program %s%s", program, allArgs);
	}
	
	@Override
	public boolean saveToCommand(Context context){
		return saveToCommand(context, FlushUtils.getString(ShuaString.strExtendCmd));
	}
}
