package com.mgyun.shua.engine;

import android.content.Context;
import android.text.TextUtils;

/** @类名：
 *  @创建：
 *  @创建日期：
 *  @说明：
 ***************************************************/
public class EdifyBuilder extends ScriptBuilder {
	@Override
	public void backup(String path) {
		//appendLine("backup_rom(\"%s\");", path);
		appendLine(FlushUtils.getString(ShuaString.strBackUpRom), path);
	}

	@Override
	public void format(String path){
		//appendLine("format(\"%s\");", path);
		appendLine(FlushUtils.getString(ShuaString.strFormat), path);
	}

	@Override
	public void installZip(String path, String replaceSdcard){
		//appendLine("install_zip(\"%s\");", replaceStart(path, "/mnt/sdcard", "/sdcard"));
		// appendLine(Utils.getString(ShuaString.strInstallZip), replaceStart(path, "/mnt/sdcard", "/sdcard"));
		if (TextUtils.isEmpty(replaceSdcard)){
			appendLine(FlushUtils.getString(ShuaString.strInstallZip), replaceStart(path, "/mnt/sdcard", "/sdcard"));
		}else{
			String newPath = replaceStart(path, "/mnt/sdcard", "/sdcard");
			newPath = replaceStart(path, "/sdcard", replaceSdcard);
			appendLine(FlushUtils.getString(ShuaString.strInstallZip), newPath);
		}
	}

	@Override
	public void print(String format, Object... args){
		//appendLine("ui_print(\"%s\");", String.format(format, args).replace("\"", "\\\""));
		appendLine(FlushUtils.getString(ShuaString.strUiPrint),
				String.format(format, args).replace("\"", "\\\""));
	}

	@Override
	public void restore(String path, boolean boot, boolean system,
			boolean data, boolean cache, boolean sdext) {
		Object[] args = new Object[6];
		args[0] = path;
		if (boot)
			args[1] = "boot";
		else
			args[1] = "noboot";
		if (system)
			args[2] = "system";
		else
			args[2] = "nosystem";
		if (data)
			args[3] = "data";
		else
			args[3] = "nodata";
		if (cache)
			args[4] = "cache";
		else
			args[4] = "nocache";
		if (sdext)
			args[5] = "sd-ext";
		else
			args[5] = "nosd-ext";
		//appendLine("restore_rom(\"%s\", \"%s\", \"%s\", \"%s\", \"%s\", \"%s\");", args);
		appendLine(FlushUtils.getString(ShuaString.strRestoreRom), args);
	}

	@Override
	public void runProgram(String program, String... args){
		String allArgs = "";
		for (int i=0; i<args.length; i++){
			allArgs += ", \"" + args[i]+"\"";
		}
		appendLine("run_program(\"%s\"%s);", program, allArgs);
	}
	
	@Override
	public boolean saveToCommand(Context context){
		return saveToCommand(context, FlushUtils.getString(ShuaString.strExtendCmd));
	}
}
