package com.mgyun.shua.engine;

import android.content.Context;
import android.content.SharedPreferences;

public class ShuaEngine {
	private Context mAppContext;
	public static ShuaEngine clientInstance;
	private SharedPreferences sharePreference;
	public SharedPreferences.Editor shareEditor;
	
	
	//供外部调用，获取唯一实例
	public static synchronized ShuaEngine getInstance(Context context){
		Context appContext = context.getApplicationContext();
	    if(clientInstance==null || clientInstance.mAppContext!=appContext){
			clientInstance = new ShuaEngine(appContext);
		}
		return clientInstance;
	}
	
	private ShuaEngine(Context appContext){
    	mAppContext = appContext;
    	sharePreference = mAppContext.getSharedPreferences("refreshparams", Context.MODE_PRIVATE);
		shareEditor = sharePreference.edit();
	}
	
	//获取recovery
	public String getRecovery(){
		return sharePreference.getString("recovery", "");
	}
	
	public void setRecovery(String _newRecovery){
		shareEditor.putString("recovery", _newRecovery); 
		shareEditor.commit();
	}
	
	//获取device适配数据
	public String getDeviceJson(){
		return sharePreference.getString("devicejson", "");
	}
	
	public void setDeviceJson(String _devicejson){
		shareEditor.putString("devicejson", _devicejson); 
		shareEditor.commit();
	}
	
	//attachment
	public String getAttachMent(){
		return sharePreference.getString("attachment", "");
	}
	
	public void setAttachMent(String _attachment){
		shareEditor.putString("attachment", _attachment); 
		shareEditor.commit();
	}	
}
