package com.mgyun.shua.general.utils;

import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

/**
 * 解密
 * Created by holmes on 10/25/14.
 */
public class Decoder {

    public static final byte KEY = 0x73;
    public static final int V = 251;

    /**
     * 解密初始化string
     * @param clss
     */
    public static void decodeClass(Class<?> clss){
        Field[] fields = clss.getFields();
        if (fields == null){
            return;
        }

        for (int i = 0; i < fields.length; i ++){
            Field field = fields[i];
            int modifiers = field.getModifiers();
            boolean isStatic = (modifiers & Modifier.STATIC) != 0;
            if (field.getType() == String.class && isStatic){
                field.setAccessible(true);
                try {
                    String value = (String) field.get(null);
                    String decoded = decode(value);
                    field.set(null, decoded);
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }else if (field.getType() == Boolean.class && isStatic){
                field.setAccessible(true);
                try {
                    field.set(null, true);
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    /**
     * 解密字符串
     * @param encoded
     * @return
     */
    public static String decode(String encoded){
        try {
            byte[] o = Hex.decodeHex(encoded.toCharArray());
            for (int i = 0; i < o.length; i ++) {
                int oi = 0xFF & o[i];
                o[i] = (byte) (((oi << 4) | (oi >> 4)) & 0xFF);
            }
            return new String(o, "UTF-8");
        } catch (DecoderException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return null;
    }
    
}
