package com.mgyun.shua.general.utils;

import java.io.File;

import z.hol.shellandroid.Shell;
import android.content.Context;

public final class SuBinaryUtils {
	public static final String ACTION_CHECK_SU = "com.mgyun.shua.su.check.su";

	// ** su names
	public static final String DEFAULT_SU_NAME = "su";
	private static final String SU_NAME_430 = "su_2";
	private static final String SU_NAME_INTEL = "su_3";
	
	/**
	 * 获取当前系统可用的su名称
	 * @return
	 */
	public static String ensureSuName(){
	    int c = CpuUtils.getCpuType();
	    if (c == CpuUtils.CPU_INTEL){
	        return SU_NAME_INTEL;
	    }else{
	        if (android.os.Build.VERSION.SDK_INT >= 18){
	            return SU_NAME_430;
	        }else{
	            return DEFAULT_SU_NAME;
	        }
	    }
	}
	
	/**
	 * 内部挂载
	 * @param context
	 * @param shell
	 */
	public static void internalMount(Context context, Shell shell){
		File suFile = context.getFileStreamPath("su");
		shell.exec(true, suFile.getAbsolutePath() + " -r /system rw");
	}
}
