package com.mgyun.shua.model;

/**
 * 刷新过程信息
 * @author holmes
 *
 */
public interface FlushGuider {

	/**
	 * 获取机型ProduectID
	 * @return
	 */
	String getProductId();
	
	/**
	 * 获取sd卡的替换字符, 用于替换在脚本中的sdcard字符
	 * @return
	 */
	String getReplaceSdcard();
	
	/**
	 * 获取sd卡的有效路径  
	 * @return
	 */
	String[] getSdcardDevices();
	
	/**
	 * 获取recovery的版本号
	 * @return
	 */
	int getRecoveryVersion();
	
	/**
	 * 获取recovery的刷入脚本
	 * @return 若为空则代表使用flash_image这个可执行文件来刷写
	 */
	String getFlushRecovery();
	
	/**
	 * 获取recovery刷入验证脚本
	 * @return
	 */
	String getFlushRecoveryChecker();
	
	/**
	 * 获取reboot的特殊指令脚本
	 * @return 为空时, 使用 {@link #getRebootRecovery()}
	 */
	String getRebootRecoverySpecial();
	
	/**
	 * 获取普通的Reboot Recovery的脚本
	 * @return 为空, 则用 "reboot recovery"
	 */
	String getRebootRecovery();
	
	/**
	 * 是否需要Preinstall
	 * @return
	 */
	boolean isNeedPerinsatll();
}
