package com.mgyun.shua.model;

import java.io.File;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.text.TextUtils;

/**
 * 刷新方案
 * @author holmes
 *
 */
public class FlushPlan implements FlushResource, FlushGuider{
	
	/**
	 * 生成刷新方案
	 */
	public FlushPlan() {
		// This is Auto-generated constructor stub
		File fileDir = new File(FlushData.FILE_RECOVERY);
		if (!fileDir.getParentFile().exists()){
			fileDir.getParentFile().mkdirs();
		}
		fileDir = null;
		fileDir = new File(FlushData.FILE_FLUSH);
		if (!fileDir.getParentFile().exists()){
			fileDir.getParentFile().mkdirs();
		}
		fileDir = null;
	}

	@Override
	public String getProductId() {
		// This is Auto-generated method stub
		return mProductId;
	}

	@Override
	public String getReplaceSdcard() {
		// This is Auto-generated method stub
		return mReplaceSdcard;
	}

	@Override
	public String[] getSdcardDevices() {
		// This is Auto-generated method stub
		return mSdcardDevices;
	}

	@Override
	public int getRecoveryVersion() {
		// This is Auto-generated method stub
		return mRecoveryVersion;
	}

	@Override
	public String getFlushRecovery() {
		// This is Auto-generated method stub
		return mFlashRecovery;
	}

	@Override
	public String getFlushRecoveryChecker() {
		// This is Auto-generated method stub
		return mFlashRecoveryChecker;
	}

	@Override
	public String getRebootRecoverySpecial() {
		// This is Auto-generated method stub
		return mRebootSpecial;
	}

	@Override
	public String getRebootRecovery() {
		// This is Auto-generated method stub
		return mReboot;
	}

	@Override
	public boolean isNeedPerinsatll() {
		// This is Auto-generated method stub
		return !TextUtils.isEmpty(getPreinstallUrl());
	}

	@Override
	public String getRecoveryUrl() {
		// This is Auto-generated method stub
		return mRecovery;
	}

	@Override
	public String getRecoveryMd5() {
		// This is Auto-generated method stub
		return mRecoveryMd5;
	}

	@Override
	public String getPreinstallUrl() {
		// This is Auto-generated method stub
		return mPreinstall;
	}

	@Override
	public String getPreinstallMd5() {
		// This is Auto-generated method stub
		return mPreinstallMd5;
	}
	
	@Override
	public String getFlushUrl() {
		// This is Auto-generated method stub
		return mFlushUrl;
	}

	@Override
	public String getAttachUrl() {
		// This is Auto-generated method stub
		return mAttachUrl;
	}

	private String mRecovery;
	private String mRecoveryMd5;
	private String mPreinstall;
	private String mPreinstallMd5;
	private String mFlushUrl;
	private String mAttachUrl;
	
	private String mProductId;
	private String mReplaceSdcard;

	private String[] mSdcardDevices;
	private int mRecoveryVersion;
	private String mFlashRecovery;
	private String mFlashRecoveryChecker;
	private String mRebootSpecial;
	private String mReboot;
	
	/**
	 * 从json初始化
	 * @param json
	 * @return
	 */
	public boolean initFromJson(String json){
		JSONObject obj;
		try {
			obj = new JSONObject(json);
		} catch (JSONException e) {
			// This is Auto-generated catch block
			e.printStackTrace();
			return false;
		}
		
		String recovery = obj.optString("Recovery");
		String recoveryMd5 = obj.optString("RecoveryMD5");
		String preinstall = obj.optString("Preinstall");
		String preinstallMd5 = obj.optString("PreinstallMD5");
		String flushUrl = obj.optString("flush");
		String attachUrl = obj.optString("attachment");
		
		String productId = obj.optString("ProductId");
		String replaceSdcard = obj.optString("RecSdcard");
		
		JSONArray array = obj.optJSONArray("SdcardDevice");
		String[] sdcardDevices = null; // SdcardDevice
		if (array != null){
			final int count = array.length(); 
			sdcardDevices = new String[count];
			for (int i = 0; i < count; i ++){
				try {
					String sd = array.getString(i);
					sdcardDevices[i] = sd;
				} catch (JSONException e) {
					// This is Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
		int recoveryVersion = obj.optInt("RecoveryVer");
		String flashRecovery = obj.optString("FlashRecovery");
		String flashRecoveryChecker = obj.optString("recoveryflashChecker");
		String rebootSpecial = obj.optString("RebootRecoverySpecial");
		String reboot = obj.optString("RebootRecovery");
		
		
		mRecovery = recovery;
		mRecoveryMd5 = recoveryMd5;
		mPreinstall = preinstall;
		mPreinstallMd5 = preinstallMd5;
		mFlushUrl = flushUrl;
		mAttachUrl = attachUrl;
		
		mProductId = productId;
		mReplaceSdcard = replaceSdcard;

		mSdcardDevices = sdcardDevices;
		
		mRecoveryVersion = recoveryVersion;
		mFlashRecovery = flashRecovery;
		mFlashRecoveryChecker = flashRecoveryChecker;
		mRebootSpecial = rebootSpecial;
		mReboot = reboot;
		
		
		return true;
	}
}
