package com.mgyun.shua.protector;

import z.hol.general.ConcurrentCanceler;

public abstract class AbsCancelableTask implements CancelableTask{
	
	protected ConcurrentCanceler mCanceler = new ConcurrentCanceler();
	protected Status mStatus = Status.NORMAL;
	private OnCancelListener mOnCancelListener;

	@Override
	public void cancel() {
		// TODO Auto-generated method stub
		mCanceler.cancel();
		mStatus = Status.CANCELING;
	}

	@Override
	public boolean isCanceled() {
		// TODO Auto-generated method stub
		return mCanceler.isCanceled();
	}

	@Override
	public Status getCurrentStatus() {
		// TODO Auto-generated method stub
		return mStatus;
	}
	
	/**
	 * 设置当前运行状态
	 * @param status
	 */
	protected void setCurrentStatus(Status status){
		mStatus = status;
	}
	
	protected void statusRunning(){
		mStatus = Status.RUNNING;
	}
	
	protected void statusFinised(){
		mStatus = Status.FINISHED;
	}

	@Override
	public void setOnCancelListener(OnCancelListener listener) {
		// TODO Auto-generated method stub
		mOnCancelListener = listener;
	}
	
	protected void invokeOnCancel(){
		mStatus = Status.CANCELED;
		if (mOnCancelListener != null){
			mOnCancelListener.onCancel(this);
		}
	}
}
