package com.yiutil.tools;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.res.Resources;
import android.util.DisplayMetrics;
import android.util.Log;

/** @类名：ApkUtil
 *  @创建：
 *  @创建日期：
 *  @说明：
 ***************************************************/
public class ApkUtil{ 
	/**
	 * 获取未安装的APK图标
	 * @param apkPath
	 * apk包的文件路径  ，Package 解释器, 是隐藏的 
	 * PackageParser packageParser = new PackageParser(apkPath);   
	 */
	@SuppressWarnings("rawtypes")
	public static void getUninstallAPKInfo(Context _context,String apkPath){  
        String PATH_PackageParser = "android.content.pm.PackageParser";  
        String PATH_AssetManager = "android.content.res.AssetManager";  
        try{  
            Class pkgParserCls = Class.forName(PATH_PackageParser);  
            Class[] typeArgs = new Class[1];  
            typeArgs[0] = String.class;  
            Constructor pkgParserCt = pkgParserCls.getConstructor(typeArgs);  
            Object[] valueArgs = new Object[1];  
            valueArgs[0] = apkPath;  
            Object pkgParser = pkgParserCt.newInstance(valueArgs);  
            LogUtil.LogShow("ApkUtil", "pkgParser:" + pkgParser.toString(),LogUtil.INFO);  
            // 这个是与显示有关的, 里面涉及到一些像素显示等等, 我们使用默认的情况  
            DisplayMetrics metrics = new DisplayMetrics();  
            metrics.setToDefaults();  
            typeArgs = new Class[4];  
            typeArgs[0] = File.class;  
            typeArgs[1] = String.class;  
            typeArgs[2] = DisplayMetrics.class;  
            typeArgs[3] = Integer.TYPE;  
            Method pkgParser_parsePackageMtd = pkgParserCls.getDeclaredMethod("parsePackage",  
                    typeArgs);  
            valueArgs = new Object[4];  
            valueArgs[0] = new File(apkPath);  
            valueArgs[1] = apkPath;  
            valueArgs[2] = metrics;  
            valueArgs[3] = 0;  
            Object pkgParserPkg = pkgParser_parsePackageMtd.invoke(pkgParser, valueArgs);  
            // 应用程序信息包, 这个公开的, 不过有些函数, 变量没公开  
            Field appInfoFld = pkgParserPkg.getClass().getDeclaredField("applicationInfo");  
            ApplicationInfo info = (ApplicationInfo) appInfoFld.get(pkgParserPkg); 
            
            // uid 输出为"-1"，原因是未安装，系统未分配其Uid。  
            LogUtil.LogShow("ApkUtil", "pkg:" + info.packageName + " uid=" + info.uid,Log.INFO);  
            LogUtil.LogShow("ApkUtil", "name:" + info.name,Log.INFO);  
            Class assetMagCls = Class.forName(PATH_AssetManager);  
            Constructor assetMagCt = assetMagCls.getConstructor((Class[]) null);  
            Object assetMag = assetMagCt.newInstance((Object[]) null);  
            typeArgs = new Class[1];  
            typeArgs[0] = String.class;  
            Method assetMag_addAssetPathMtd = assetMagCls.getDeclaredMethod("addAssetPath",  
                    typeArgs);  
            valueArgs = new Object[1];  
            valueArgs[0] = apkPath;  
            assetMag_addAssetPathMtd.invoke(assetMag, valueArgs);  
            Resources res = _context.getResources();  
            typeArgs = new Class[3];  
            typeArgs[0] = assetMag.getClass();  
            typeArgs[1] = res.getDisplayMetrics().getClass();  
            typeArgs[2] = res.getConfiguration().getClass();  
            Constructor resCt = Resources.class.getConstructor(typeArgs);  
            valueArgs = new Object[3];  
            valueArgs[0] = assetMag;  
            valueArgs[1] = res.getDisplayMetrics();  
            valueArgs[2] = res.getConfiguration();  
            res = (Resources) resCt.newInstance(valueArgs);  
            CharSequence label = null;
          
            //读取apk程序的名称
            if (info.labelRes != 0){  
                label = res.getText(info.labelRes);  
            }  
         
            LogUtil.LogShow("ApkUtil", "label=" + label,Log.INFO);  
            //读取apk程序的图标  
            if (info.icon != 0){  
                //Drawable icon = res.getDrawable(info.icon);   
            }  
        } catch (Exception e) {  
            e.printStackTrace();  
        }  
    } 
	
	//获取程序签名
    public static String getAppSignature(Context context,String packname){  
    	try {  
            PackageInfo packinfo =context.getPackageManager().getPackageInfo(
        		          packname, PackageManager.GET_SIGNATURES);    
            return packinfo.signatures[0].toCharsString();  
        } catch (NameNotFoundException e) {  
            e.printStackTrace();  
            return null;  
        }  
    } 
}
