package com.yiutil.tools;

import java.util.HashMap;

/** @类名：VolumeUtil
 *  @创建：
 *  @创建日期：
 *  @说明：
 ***************************************************/
public class CookieManager{
	private HashMap<String,Object> cookies;
	private static CookieManager instance;
	//初始化cookie管理器
	public synchronized static CookieManager getInstance(){
		if(instance==null){
			instance = new CookieManager();
		}
		return instance;
	}
	
	private CookieManager(){
		cookies=new HashMap<String, Object>();
	}
	
	// 获得指定的cookie值
	public Object getCookieValue(String key){
		return cookies.get(key);
	}
	
	//存储一个cookie
	public void addCookie(String key,Object value){
		cookies.put(key, value);
	}
	
	//cookie是否已经有此key
	public boolean containsKey(String key){
		return cookies.containsKey(key);
	}
	
	//把value为空的cookies清空
	public void clearCookies(){
		cookies.clear();
	}
}

