package com.yiutil.tools;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Proxy;

public class NetUtil {

    public static boolean isNetworkConnected(Context context) {
        if (context != null) {
            ConnectivityManager mConnectivityManager = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo mNetworkInfo = mConnectivityManager.getActiveNetworkInfo();
            if (mNetworkInfo != null) {
                return mNetworkInfo.isAvailable();
            }
        }
        return false;
    }

    public static int isNetConnected(Context context) {
        int bRet = 0;
        ConnectivityManager connec = (ConnectivityManager) context.getSystemService("connectivity");
        NetworkInfo info = connec.getActiveNetworkInfo();
        if ((info != null) && (info.isAvailable())) {
            if (info.getType() == 1) {
                bRet = 3;
            } else if (info.getType() == 0) {
                String proxyHost = Proxy.getDefaultHost();
                if (proxyHost != null)
                    bRet = 1;
                else {
                    bRet = 2;
                }
            }
        }
        return bRet;
    }
}
