package com.yiutil.tools;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

/** @类名：VolumeUtil
 *  @创建：
 *  @创建日期：
 *  @说明：
 ***************************************************/
public class ShellUtil{
    public final Runtime shell;
   
    public static boolean isRoot(Runtime r, long wait)
                       throws IOException, InterruptedException{
       boolean root = false;
       Process p = null;
       BufferedReader errReader = null;
       String suPath = getFilePath("su");
       if (suPath != null) {
           p = Runtime.getRuntime().exec("su");
           Thread.sleep(wait);
           errReader = new BufferedReader(new InputStreamReader(p.getErrorStream()));
           if (!errReader.ready()) {
              root = true;
              p.destroy();
           }
       }
       return root;
    }

    public static String getFilePath(String fileName) {
       String[] path = { "/sbin/", 
                     "/vendor/bin/", "/system/sbin/", "/system/xbin/", "/system/bin/", 
               "/data/bin/" };
       for (String filePath : path) {
          File file = new File(filePath + fileName);
          if (file.exists()) {
             return file.getAbsolutePath();
          }
       }
       return null;
    }

    public static boolean exeCmd(String _command, long wait) 
    		throws IOException, InterruptedException{
       boolean ret = false;
       Process p = null;
       BufferedReader errReader = null;
       p = Runtime.getRuntime().exec(_command);
       Thread.sleep(wait);
       errReader = new BufferedReader(
                new InputStreamReader(p.getErrorStream()));
       if (!errReader.ready()) {
           ret = true;
           p.destroy();
       }
       return ret;
    }

    public ShellUtil(Runtime runtime){
       this.shell = runtime;
    }

    public static boolean deleteFile(String file) throws IOException{
       String[] cmds = { "rm", file };
       boolean ret = false;
       Process p = null;
       BufferedReader errReader = null;
       p = Runtime.getRuntime().exec(cmds);
       errReader = new BufferedReader(
           new InputStreamReader(p.getErrorStream()));
       if (!errReader.ready()) {
           ret = true;
           p.destroy();
       }
       return ret;
   }

   public final Process delete(String file) throws IOException {
       String[] cmds = { "rm", "-r", file };
       return this.shell.exec(cmds);
   }

   public final Process deleteMult(String[] cmds) throws IOException {
       return this.shell.exec(cmds);
   }

   public final Process deleteDirectory(String dire) throws IOException{
       String[] cmds = { "rm", "-r", dire };
       return this.shell.exec(cmds);
   }

   public final Process createFile(String file)
       throws IOException{
       String[] cmds = { "touch", file };
       return this.shell.exec(cmds);
   }

   public final Process createDirectory(String dire)
       throws IOException{
       String[] cmds = { "mkdir", dire };
       return this.shell.exec(cmds);
   }

   public final Process moveFile(String src, String dir)
        throws IOException{
       String[] cmds = { "mv", src, dir };
       return this.shell.exec(cmds);
   }

   public static boolean copyFile(String src, String dir, long wait)
                       throws IOException, InterruptedException{
       boolean bsuccess = false;
       Process p = null;
       String[] cmds = { "cp", "-r", src, dir };
       BufferedReader errReader = null;
       p = Runtime.getRuntime().exec(cmds);
       Thread.sleep(wait);
       errReader = new BufferedReader(
                 new InputStreamReader(p.getErrorStream()));
       if (!errReader.ready()) {
           bsuccess = true;
           p.destroy();
       }
       return bsuccess;
   }

   public final Process linkFile(String src, String dir)
                          throws IOException{
       String[] cmds = { "ln", "-l", src, dir };
       return this.shell.exec(cmds);
   }

   public final Process du_s(String file) throws IOException {
       String[] cmds = { "du", "-s", file };
       return this.shell.exec(cmds);
   }

   public final Process ls_lhd(String file) throws IOException {
       String[] cmds = { "ls", "-l", file };
       return this.shell.exec(cmds);
   }

   public final Process ls_Directory(String directory) throws IOException {
       if (directory.equals("/"))
           directory = "";
       String[] cmds = { "ls", "-a", directory };
       return this.shell.exec(cmds);
   }
}
